﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
Sub Class_Globals
	Type B4XFormatStringData (FormatFont As B4XFont, ReplaceString As String, TextColor As Int, BackColor As Int, SearchType As Byte, _
	RangeStart As String, RangeEnd As String, IncludeStartEnd As Boolean, IgnoreCase As Boolean)
	Public SEARCH_TYPE_EQUALS = 1, SEARCH_TYPE_GREATERTHAN = 2, SEARCH_TYPE_LESSTHAN = 3, SEARCH_TYPE_BETWEEN = 4 As Int, SEARCH_TYPE_IN = 5 As Int
	Public FormatFieldName As String  'If we want to format a field OTHER than the one we are testing then set this - otherwise leave blank
	Private formats As List
	Private xui As XUI
End Sub

Public Sub Initialize
	formats.Initialize
	Dim d As B4XFormatStringData = CreateDefaultFormat
	AddFormatData(d, SEARCH_TYPE_EQUALS, True, True)
End Sub

Private Sub CreateDefaultFormat As B4XFormatStringData
	Dim d As B4XFormatStringData
	d.Initialize
	d.SearchType = SEARCH_TYPE_EQUALS
	d.IncludeStartEnd = True
	d.IgnoreCase = True
	Return d
End Sub

'Returns a copy of the default format
Public Sub NewFormatData As B4XFormatStringData
	Return CopyFormatData(GetDefaultFormat)
End Sub

'Creates a copy of the given format data.
'This is useful if you want to create a similar format for a different range.
Public Sub CopyFormatData (Data As B4XFormatStringData) As B4XFormatStringData
	Dim d As B4XFormatStringData
	d.Initialize
'	d.Minimumchars = Data.Minimumchars
	If Data.FormatFont.IsInitialized Then
		#if Not(B4J) OR UI
		d.FormatFont = xui.CreateFont(Data.FormatFont.ToNativeFont, Data.FormatFont.Size)
		#end if
	End If
	d.ReplaceString = Data.ReplaceString
	d.TextColor = Data.TextColor
	d.SearchType = Data.SearchType
	d.RangeStart = Data.RangeStart
	d.RangeEnd = Data.RangeEnd
	d.IncludeStartEnd = Data.IncludeStartEnd
	d.IgnoreCase = Data.IgnoreCase
	Return d
End Sub

'Adds a format data to the formatter. Note that each data object should be used for a single range. Use CopyFormatData to create copies.
'The format datas are stored in a list. When a number is formatted it looks for a data with a matching range. Datas added last will be checked first.
'IncludeStartEnd - Whether the range is inclusive or not.
Public Sub AddFormatData (Data As B4XFormatStringData, SearchType As Byte, IncludeStartEnd As Boolean, IgnoreCase As Boolean)
'	If IncludeStartEnd = False Then
'		RangeStart = RangeStart + factor
'		RangeEnd = RangeEnd - factor
'	End If
'	RangeStart = RangeStart - factor / 2
'	RangeEnd = RangeEnd + factor / 2
	Data.SearchType = SearchType
	Data.IncludeStartEnd = IncludeStartEnd
	Data.IgnoreCase = IgnoreCase
	formats.Add(Data)
End Sub
'Returns the default format.
Public Sub GetDefaultFormat As B4XFormatStringData
	Return formats.Get(0)
End Sub

'Gets the format data that matches the passed number.
Public Sub GetFormatData (Str As String) As B4XFormatStringData
	
	If formats.Size = 1 Then Return formats.Get(0)  'we only have the defauls so do nothing
	For i = formats.Size - 1 To 1 Step - 1
		Dim d As B4XFormatStringData = formats.Get(i), X As Int
		Select d.SearchType
			Case SEARCH_TYPE_EQUALS
				If d.RangeStart.Length > 0 Then
					If d.IgnoreCase Then
						If d.RangeStart.EqualsIgnoreCase(Str) Then Return d
					Else
						If d.RangeStart = Str Then Return d
					End If
				End If
			Case SEARCH_TYPE_GREATERTHAN
				If d.RangeStart.Length > 0 Then	
					If d.IgnoreCase Then
						X = Str.ToLowerCase.CompareTo(d.RangeStart.ToLowerCase)
						If ((X = 0) And d.IncludeStartEnd) Or (X > 0) Then Return d
					Else
						X = Str.CompareTo(d.RangeStart)
						If ((X = 0) And d.IncludeStartEnd) Or (X > 0) Then Return d
					End If
				End If
			Case SEARCH_TYPE_LESSTHAN
				If d.RangeStart.Length > 0 Then
					If d.IgnoreCase Then
						X = Str.ToLowerCase.CompareTo(d.RangeStart.ToLowerCase)
						If ((X = 0) And d.IncludeStartEnd) Or (X < 0) Then Return d
					Else
						X = Str.CompareTo(d.RangeStart)
						If ((X = 0) And d.IncludeStartEnd) Or (X < 0) Then Return d
					End If
				End If
			Case SEARCH_TYPE_BETWEEN
				If d.RangeStart.Length > 0 Then
					If d.IgnoreCase Then
						X = Str.ToLowerCase.CompareTo(d.RangeStart.ToLowerCase)
						If ((X = 0) And d.IncludeStartEnd) Or (X > 0) Then
							X = Str.ToLowerCase.CompareTo(d.RangeEnd.ToLowerCase)
							If ((X = 0) And d.IncludeStartEnd) Or (X < 0) Then Return d
						End If
					Else
						X = Str.CompareTo(d.RangeStart.ToLowerCase)
						If ((X = 0) And d.IncludeStartEnd) Or (X > 0) Then
							X = Str.CompareTo(d.RangeEnd.ToLowerCase)
							If ((X = 0) And d.IncludeStartEnd) Or (X < 0) Then Return d
						End If
					End If
				End If
			Case SEARCH_TYPE_IN
				If d.IgnoreCase Then
					If Str.ToLowerCase.Contains(d.RangeStart.ToLowerCase) Then Return d
				Else
					If Str.Contains(d.RangeStart) Then Return d
				End If
			End Select
	Next
	Return formats.Get(0)
End Sub

'Formats the number and returns the formatted string.
'Public Sub Format (Str As String) As String
'	If Str ="" Then Return ""
'	Dim data As B4XFormatStringData = GetFormatData (Str)
'	'Dim sb As StringBuilder
'	'sb.Initialize
'	Return Str
'End Sub

#if Not(B4J) OR UI
'Formats the number and sets it to the text field. Unlike Format, FormatLabel respects the format data font and text size properties.
Public Sub FormatLabel (Str As String, Label As B4XView)
	'Label.Text = Str
	If formats.Size = 1 Then Return   'we only have the default so do nothing
	Dim data As B4XFormatStringData = GetFormatData(Str)
	If data.TextColor <> 0 Then Label.TextColor = data.TextColor
	Dim pnl As B4XView = Label.Parent
	If data.BackColor <> 0 Then pnl.Color = data.BackColor
	If data.FormatFont.IsInitialized Then Label.Font = data.FormatFont
End Sub
#end if
